﻿using Plane.FormationCreator.Formation;
using Plane.FormationCreator.Views;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Data;
using System.Windows.Media;

namespace Plane.FormationCreator.Converters
{
    public class FlightTaskStatusToFillConverter : IValueConverter
    {
        static SolidColorBrush _normalFill = new SolidColorBrush(Color.FromRgb(45, 45, 45));
        static SolidColorBrush _runningFill = new SolidColorBrush(Colors.Green);
        static SolidColorBrush _PausedFill = new SolidColorBrush(Colors.Red);
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            var status = (FlightTaskStatus)value;
            if (status == FlightTaskStatus.Running)
                return _runningFill;

            if (status == FlightTaskStatus.Paused)
                return _PausedFill;


            return _normalFill;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
