﻿using Plane.Copters;
using Plane.FormationCreator.Formation;
using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Data;
using System.Windows.Media;

namespace Plane.FormationCreator.Converters
{
    public class HeartbeatCountToBrushConverter : IMultiValueConverter
    {
        private static SolidColorBrush _zeroBrush = new SolidColorBrush(Color.FromArgb(125, 125, 125, 125));
        private static SolidColorBrush _oneBrush = Copter.DefaultBrush;

        public object Convert(object[] values, Type targetType, object parameter, CultureInfo culture)
        {
            if (values[0] == DependencyProperty.UnsetValue) return _zeroBrush;
            var heartbeatCount = (ulong)values[0];
            if (heartbeatCount % 2 == 0) return _zeroBrush;
            var copter = values[1] as Copter;
            return copter == null ? _oneBrush : copter.Brush;
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, CultureInfo culture)
        {
            throw new NotSupportedException();
        }
    }
}
