﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Plane.Copters;

namespace Plane.FormationCreator.Formation
{
    public partial class FlightTaskSingleCopterInfo
    {
        public static FlightTaskSingleCopterInfo CreateForCircleTask(ICopter copter, LatLng latLngOffset, float targetAlt, short centerDirectionDeg, int radius, int rate, int turns, ushort channel3)
        {
            var info = new FlightTaskSingleCopterInfo(copter)
            {
                LatLngOffset = latLngOffset,
                TargetAlt = targetAlt,
                CenterDirectionDeg = centerDirectionDeg,
                Radius = radius,
                Rate = rate,
                Turns = turns,
                Channel3 = channel3
            };
            return info;
        }

        private short _CenterDirectionDeg;
        public short CenterDirectionDeg
        {
            get { return _CenterDirectionDeg; }
            set { Set(nameof(CenterDirectionDeg), ref _CenterDirectionDeg, value); }
        }

        private int _Radius = 1000;
        /// <summary>
        /// 圆的半径，单位为厘米。
        /// </summary>
        public int Radius
        {
            get { return _Radius; }
            set { Set(nameof(Radius), ref _Radius, value); }
        }

        private int _Rate = 20;
        /// <summary>
        /// 转圈的角速度，单位为 deg/s，范围为 -90 到 90。
        /// </summary>
        public int Rate
        {
            get { return _Rate; }
            set { Set(nameof(Rate), ref _Rate, value); }
        }

        private int _Turns = 1;
        public int Turns
        {
            get { return _Turns; }
            set { Set(nameof(Turns), ref _Turns, value); }
        }

        private ushort _Channel3 = 1500;
        public ushort Channel3
        {
            get { return _Channel3; }
            set { Set(nameof(Channel3), ref _Channel3, value); }
        }
    }
}
