﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Plane.FormationCreator.Formation
{
    public partial class FlightTask
    {
        private float _RTLAlt = 20.0f;
        public float RTLAlt
        {
            get { return _RTLAlt; }
            set { Set(nameof(RTLAlt), ref _RTLAlt, value); }
        }
        private int _RetNumAttr = 1;
        public int RetNumAttr
        {
            get { return _RetNumAttr; }
            set
            {
                Set(nameof(RetNumAttr), ref _RetNumAttr, value);
            }
        }
        public async Task RunReturnToLandTaskAsync()
        {
            int TaskCount = _flightTaskManager.Tasks.Count();
            if (TaskCount > 1)
            {
                var infos = SingleCopterInfos;
                // var infos = SingleCopterInfos.OrderByDescending(i => i.TargetAlt).ToList();
                var tasks = new Task[infos.Count];
                var tasksTmp = new Task[infos.Count];
                for (int i = 0; i < infos.Count; i++)
                {
                    var info = infos[i];

                    // var copter = info.Copter;
                    if (info.RTLStage <= 1)  // 当前阶段小于等于1时进入
                    {
                        await ReturnToLandTaskFlySingleCopterAsync(info);
                    }

                    tasksTmp[i] = ReturnToLandSecondTaskAsync(info);

                }
                await Task.WhenAll(tasksTmp).ConfigureAwait(false);
                if (_flightTaskManager.IsPaused == false)
                {
                    for (int i = 0; i < infos.Count; i++)
                    {
                        var info = infos[i];
                        info.RTLStage = 0;
                    }
                }
            }
            
        }
        public async Task MutilRunReturnToLandTaskAsync()
        {
            int TaskCount = _flightTaskManager.Tasks.Count();
            if (TaskCount > 1)
            {
                var infos = SingleCopterInfos;

                int copterCount = infos.Count;
                int integerPart = copterCount / RetNumAttr;
                int residualPart = copterCount % RetNumAttr;
                var tasksTmp = new Task[infos.Count];
                //整数部分执行返航降落
                for (int i = 0; i < integerPart; i++)
                {
                    var tasksRetutn = new Task[RetNumAttr*2];
                    //设置返航任务
                    for (int j = RetNumAttr * i; j < RetNumAttr * (i + 1); j++)
                    {
                        var info = infos[j];

                        int indexTmp = j - RetNumAttr * i;

                        // var copter = info.Copter;
                        if (info.RTLStage <= 1)  // 当前阶段小于等于1时进入
                        {
                            tasksRetutn[indexTmp] = ReturnToLandTaskFlySingleCopterAsync(info);
                        }
                        else
                        {
                            tasksRetutn[indexTmp] = Task.Run(async () => { await Task.Delay(1).ConfigureAwait(false); });
                        }

                    }

                    //设置降落任务
                    if (i > 0)
                    {

                        for (int j = RetNumAttr * (i - 1); j < RetNumAttr * (i); j++)
                        {
                            var info = infos[j];

                            int indexTmp = RetNumAttr+ j - RetNumAttr * (i-1);

                            // var copter = info.Copter;
                            if (info.RTLStage == 2)  // 当前阶段小于等于1时进入
                            {
                                tasksRetutn[indexTmp] = ReturnToLandSecondTaskAsync(info);
                            }
                            else
                            {
                                tasksRetutn[indexTmp] = Task.Run(async () => { await Task.Delay(1).ConfigureAwait(false); });
                            }
                        }



                    }
                    else {
                        //第一波返航，降落任务为空
                        for (int j = RetNumAttr * (i +1); j < RetNumAttr * (i+2); j++)
                        {
                            int indexTmp = j - RetNumAttr * i;
                            tasksRetutn[indexTmp] = Task.Run(async () => { await Task.Delay(1).ConfigureAwait(false); });
                        }


                    }
                    //开始执行这波返航和上波降落
                   await Task.WhenAll(tasksRetutn).ConfigureAwait(false);
                    //上波降落后设置为0
                   if (_flightTaskManager.IsPaused == false)
                    {
                        if (i > 0)
                        {
                            for (int j = RetNumAttr * (i - 1); j < RetNumAttr * (i); j++)
                            {
                                var info = infos[j];
                                info.RTLStage = 0;
                            }
                        }

                    }
                }










                if (residualPart > 0)
                {
                    var tasksreturn = new Task[residualPart+ RetNumAttr];
                    //余数部分开始返航
                    for (int j = integerPart * RetNumAttr; j < RetNumAttr * integerPart + residualPart; j++)
                    {
                        var info = infos[j];
                        int indexTmp = j - RetNumAttr * integerPart;
                        // var copter = info.Copter;
                        if (info.RTLStage <= 1)  // 当前阶段小于等于1时进入
                        {
                            tasksreturn[indexTmp] = ReturnToLandTaskFlySingleCopterAsync(info);
                        }
                        else
                        {
                            tasksreturn[indexTmp] = Task.Run(async () => { await Task.Delay(1).ConfigureAwait(false); });
                        }
                    }



                    //无余数的整数部分最后一波开始降落
                   // var tasksLastland = new Task[RetNumAttr];
                    for (int j = RetNumAttr * (integerPart - 1); j < RetNumAttr * (integerPart); j++)
                    {
                        var info = infos[j];

                        int indexTmp = RetNumAttr + j - RetNumAttr * integerPart;

                        // var copter = info.Copter;
                        if (info.RTLStage == 2)  // 当前阶段小于等于1时进入
                        {
                            tasksreturn[residualPart + indexTmp] = ReturnToLandSecondTaskAsync(info);
                        }
                        else
                        {
                            tasksreturn[residualPart+indexTmp] = Task.Run(async () => { await Task.Delay(1).ConfigureAwait(false); });
                        }
                    }

                    //开始执行降落和返航
                    await Task.WhenAll(tasksreturn).ConfigureAwait(false);

                    //降落后设置为0
                    if (_flightTaskManager.IsPaused == false)
                    {

                        for (int j = RetNumAttr * (integerPart - 1); j < RetNumAttr * (integerPart); j++)
                        {
                            var info = infos[j];
                            info.RTLStage = 0;
                        }


                    }










                   
                    //最后余数部分降落

                    var tasksRetutn1 = new Task[residualPart];
                    for (int j = integerPart * RetNumAttr; j < RetNumAttr * integerPart + residualPart; j++)
                    {
                        var info = infos[j];
                        int indexTmp = j - RetNumAttr * integerPart;
                        // var copter = info.Copter;
                        if (info.RTLStage == 2)  // 当前阶段小于等于1时进入
                        {
                            tasksRetutn1[indexTmp] = ReturnToLandSecondTaskAsync(info);
                        }
                        else
                        {
                            tasksRetutn1[indexTmp] = Task.Run(async () => { await Task.Delay(1).ConfigureAwait(false); });
                        }
                    }
                    await Task.WhenAll(tasksRetutn1).ConfigureAwait(false);

                    if (_flightTaskManager.IsPaused == false)
                    {

                        for (int j = integerPart * RetNumAttr; j < RetNumAttr * integerPart + residualPart; j++)
                        {
                            var info = infos[j];
                            info.RTLStage = 0;
                        }

                    }
                }
                else
                {


                    //无余数的整数部分最后一波开始降落
                    var tasksLastland = new Task[RetNumAttr];
                    for (int j = RetNumAttr * (integerPart - 1); j < RetNumAttr * (integerPart); j++)
                    {
                        var info = infos[j];

                        int indexTmp = RetNumAttr + j - RetNumAttr * integerPart;

                        // var copter = info.Copter;
                        if (info.RTLStage == 2)  // 当前阶段小于等于1时进入
                        {
                            tasksLastland[indexTmp] = ReturnToLandSecondTaskAsync(info);
                        }
                        else
                        {
                            tasksLastland[indexTmp] = Task.Run(async () => { await Task.Delay(1).ConfigureAwait(false); });
                        }
                    }
                    await Task.WhenAll(tasksLastland).ConfigureAwait(false);

                    //降落后设置为0
                    if (_flightTaskManager.IsPaused == false)
                    {

                        for (int j = RetNumAttr * (integerPart - 1); j < RetNumAttr * (integerPart); j++)
                        {
                            var info = infos[j];
                            info.RTLStage = 0;
                        }


                    }











                }

            }

        }


        //原地下降高度到15米，然后返回起飞点
        private async Task ReturnToLandTaskFlySingleCopterAsync(FlightTaskSingleCopterInfo info)
        {
            float takeOffAlt = RTLAlt;   
            int TaskCount = _flightTaskManager.Tasks.Count();

            int copterIndex = SingleCopterInfos.IndexOf(info);
            var copter = info.Copter;
            var copterPreviousTask = _flightTaskManager.Tasks[TaskCount-2].SingleCopterInfos[copterIndex]; // 倒数第二步的目标位置

            // 当该飞机被标记时，悬停并跳过飞行任务
            if ((bool)_copterManager.CopterStatus[copterIndex])
            {
                await info.Copter.HoverAsync();
                return;
            }
            DateTime dtNow = DateTime.Now;
            DateTime dtLastTime = DateTime.Now;
            TimeSpan ts = dtNow - dtLastTime;
            // 第一阶段：垂直飞行
            if (info.RTLStage == 0)
            {
                for (int j = 0; j < 3; j++)
                {
                    await info.Copter.FlyToAsync(copterPreviousTask.TargetLat, copterPreviousTask.TargetLng, takeOffAlt);
                }

                while (!info.Copter.ArrivedTarget(copterPreviousTask.TargetLat, copterPreviousTask.TargetLng, takeOffAlt))
                {
                    if (_flightTaskManager.IsPaused == true)
                    {
                        await info.Copter.HoverAsync();
                        return;
                    }
                    await Task.Delay(25).ConfigureAwait(false);

                    dtNow = DateTime.Now;
                    ts = dtNow - dtLastTime;
                    if (ts.TotalMilliseconds > 1000)
                    {
                        for (int j = 0; j < 2; j++)
                        {
                            await info.Copter.FlyToAsync(copterPreviousTask.TargetLat, copterPreviousTask.TargetLng, takeOffAlt);
                        }
                        dtLastTime = dtNow;
                    }

                    // 当该飞机被标记时，悬停并跳过飞行任务
                    if ((bool)_copterManager.CopterStatus[copterIndex])
                    {
                        await info.Copter.HoverAsync();
                        return;
                    }



                }

                info.RTLStage++;
            }

            dtNow = DateTime.Now;
            dtLastTime = DateTime.Now;
            ts = dtNow - dtLastTime;

            var copterFirstTask = _flightTaskManager.Tasks[0].SingleCopterInfos[copterIndex]; // 第一步记录的家位置
            // 第二阶段：水平飞行
            if (info.RTLStage == 1)
            {
                for (int j = 0; j < 3; j++)
                {
                    await info.Copter.FlyToAsync(copterFirstTask.TargetLat, copterFirstTask.TargetLng, takeOffAlt);
                }

                while (!info.Copter.ArrivedTarget(copterFirstTask.TargetLat, copterFirstTask.TargetLng, takeOffAlt))
                {
                    if (_flightTaskManager.IsPaused == true)
                    {
                        await info.Copter.HoverAsync();
                        return;
                    }
                    await Task.Delay(25).ConfigureAwait(false);

                    dtNow = DateTime.Now;
                    ts = dtNow - dtLastTime;
                    if (ts.TotalMilliseconds > 1000)
                    {
                        for (int j = 0; j < 2; j++)
                        {
                            await info.Copter.FlyToAsync(copterFirstTask.TargetLat, copterFirstTask.TargetLng, takeOffAlt);
                        }
                        dtLastTime = dtNow;
                    }
                    // 当该飞机被标记时，悬停并跳过飞行任务
                    if ((bool)_copterManager.CopterStatus[copterIndex])
                    {
                        await info.Copter.HoverAsync();
                        return;
                    }
                }

                info.RTLStage++;
            }
            
        }

        //在起飞点上空从15米降落到4米，然后切land模式
        private async Task ReturnToLandSecondTaskAsync(FlightTaskSingleCopterInfo info)
        {
            // await Task.Run(async () =>
            // {
            int copterIndex = SingleCopterInfos.IndexOf(info);

            // 当该飞机被标记时，悬停并跳过飞行任务
            if ((bool)_copterManager.CopterStatus[copterIndex])
            {
                await info.Copter.HoverAsync();
                return;
            }

            DateTime dtNow = DateTime.Now;
            DateTime dtLastTime = DateTime.Now;
            TimeSpan ts = dtNow - dtLastTime;

            float landAlt = 4.0f;   // 飞机降落到4m再切land模式

            var copterFirstTask = _flightTaskManager.Tasks[0].SingleCopterInfos[copterIndex]; // 第一步记录的家位置
                                                                                                // 第三阶段
            if (info.RTLStage == 2)
            {
                for (int j = 0; j < 3; j++)
                {
                    await info.Copter.FlyToAsync(copterFirstTask.TargetLat, copterFirstTask.TargetLng, landAlt);
                }

                while (!info.Copter.ArrivedTarget(copterFirstTask.TargetLat, copterFirstTask.TargetLng, landAlt))
                {
                    if (_flightTaskManager.IsPaused == true)
                    {
                        await info.Copter.HoverAsync();
                        return;
                    }
                    await Task.Delay(25).ConfigureAwait(false);

                    dtNow = DateTime.Now;
                    ts = dtNow - dtLastTime;
                    if (ts.TotalMilliseconds > 1000)
                    {
                        for (int j = 0; j < 2; j++)
                        {
                            await info.Copter.FlyToAsync(copterFirstTask.TargetLat, copterFirstTask.TargetLng, landAlt);
                        }
                        dtLastTime = dtNow;
                    }
                    // 当该飞机被标记时，悬停并跳过飞行任务
                    if ((bool)_copterManager.CopterStatus[copterIndex])
                    {
                        await info.Copter.HoverAsync();
                        return;
                    }
                }

                info.RTLStage++;
            }

            // 切到land模式
            if (_flightTaskManager.IsPaused == true)
            {
                await info.Copter.HoverAsync();
                return;
            }
            var copter = info.Copter;
            if (info.RTLStage == 3)   // 下降过程
            {
                for (int j = 0; j < 5; j++)   // added by ZJF
                {
                    // await copter.ReturnToLaunchAsync();
                    await copter.LandAsync();   // 修改为降落模式
                    await Task.Delay(10);
                }
            }

            // });
        }
    }
}
