﻿using Plane.Windows.IniHelper;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Plane.FormationCreator.Util
{
    public static class VersionControl
    {
        public static int Version = 0;
        /// <summary>
        /// 是否是完整版本 仅在Version = 255时为完整版本
        /// </summary>
        public static bool IsFullVersion = false;

        /// <summary>
        /// 默认的飞机上限
        /// </summary>
        public static int CopterUpperLimit = 50;

        public static void GetVersionFromIni()
        {
            IniFiles iniFiles = new IniFiles();

            int intTemp;
            string readvalue;

            readvalue = iniFiles.IniReadvalue("Version", "Version");
            if (readvalue != "" && int.TryParse(readvalue, out intTemp))
                Version = int.Parse(readvalue);
            IsFullVersion = Version == 255;

            readvalue = iniFiles.IniReadvalue("Version", "CopterUpperLimit");
            if (readvalue != "" && int.TryParse(readvalue, out intTemp))
                CopterUpperLimit = int.Parse(readvalue);
        }
    }
}
